"use strict";
//  Copyright PrimeObjects Software Inc. and other contributors <https://www.primeobjects.com/>
//
//  This source code is licensed under the MIT license.
//  The detail information can be found in the LICENSE file in the root directory of this source tree.
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Avatar = void 0;
var react_1 = __importStar(require("react"));
var lodash_1 = require("lodash");
var svg_1 = __importDefault(require("./svg"));
var img_1 = __importDefault(require("./img"));
var gradient_div_1 = __importDefault(require("./gradient-div"));
var primeobjects_helper_util_1 = require("primeobjects-helper-util");
var react_2 = require("@headlessui/react");
var lodash_2 = require("lodash");
var styles = {
    count: { fontSize: 8, color: primeobjects_helper_util_1.COLORS.WHITE, alignSelf: "center" }
};
var Avatar = function (props) {
    var countStyle = props.countStyle, hide = props.hide, count = props.count, menuItems = props.menuItems, nameStyle = props.nameStyle, svgStyle = props.svgStyle, colorFromName = props.colorFromName, imgStyle = props.imgStyle, menuPosition = props.menuPosition, showName = props.showName;
    var wrapperClassName = props.wrapperClassName ? props.wrapperClassName : "";
    var wrapperStyle = props.wrapperStyle ? props.wrapperStyle : {};
    var userClassName = props.userClassName ? props.userClassName : "";
    var userStyle = props.userStyle ? props.userStyle : {};
    var _a = (0, react_1.useState)({}), data = _a[0], setData = _a[1];
    var backgroundColor = (0, primeobjects_helper_util_1.isNonEmptyString)(props.backgroundColor) ? props.backgroundColor : primeobjects_helper_util_1.COLORS.WHITE;
    var borderColor = (0, primeobjects_helper_util_1.isNonEmptyString)(props.borderColor) ? props.borderColor : primeobjects_helper_util_1.COLORS.BLACK;
    var color = (0, primeobjects_helper_util_1.isNonEmptyString)(props.color) ? props.color : borderColor;
    var display = (0, primeobjects_helper_util_1.getRecordDisplay)(data);
    var nameClass = props.nameClass ? props.nameClass : "";
    var imgClass = props.imgClass ? props.imgClass : "";
    var countWrapperStyle = props.countWrapperStyle ? props.countWrapperStyle : {};
    if (colorFromName) {
        backgroundColor = (0, primeobjects_helper_util_1.stringToColor)(display);
        borderColor = backgroundColor;
        color = primeobjects_helper_util_1.COLORS.WHITE;
    }
    (0, react_1.useEffect)(function () {
        setData(props.data ? (0, lodash_1.cloneDeep)(props.data) : {});
    }, [props.data]);
    var size = props.size ? props.size : 38;
    var firstName = data.firstName, lastName = data.lastName, avatar = data.avatar, currentStatus = data.currentStatus;
    if (!(0, primeobjects_helper_util_1.isNonEmptyString)(firstName) && !(0, primeobjects_helper_util_1.isNonEmptyString)(firstName)) {
        firstName = display.split(" ")[0];
        if (display.split(" ").length > 1)
            lastName = display.split(" ")[1];
    }
    var onClick = function () {
        props.onClick && props.onClick(data);
    };
    var renderName = function () {
        if (!showName)
            return null;
        return (react_1.default.createElement(gradient_div_1.default, { tooltip: display, className: "flex-1 font-medium text-base whitespace-nowrap flex flex-row items-center over", style: { height: size, marginLeft: size / 3, width: "calc(100% - ".concat((0, lodash_2.round)(size / 3, 0), "px)") }, gradientAreaWidth: props.nameGradientAreaWidth, gradientStages: props.nameGradientStages, gradientColorRGB: props.nameGradientColorRGB, onChangeOverflow: props.nameOnChangeOverflow }, display));
    };
    var renderAvatar = function () {
        return (0, primeobjects_helper_util_1.isNonEmptyString)(avatar) ? (react_1.default.createElement(img_1.default, { className: "rounded-full border border-gray-20 ".concat(imgClass), src: avatar, alt: "", style: __assign({ width: size }, imgStyle) })) : (0, primeobjects_helper_util_1.isNonEmptyString)(firstName) || (0, primeobjects_helper_util_1.isNonEmptyString)(firstName) ? (react_1.default.createElement("div", { className: "flex flex-row items-center rounded-full border ".concat(nameClass), style: __assign({ minWidth: size, minHeight: size, borderColor: borderColor, backgroundColor: backgroundColor }, nameStyle) },
            react_1.default.createElement("div", { className: "flex flex-row justify-center w-full" },
                react_1.default.createElement("span", { style: { color: color } }, (0, primeobjects_helper_util_1.isNonEmptyString)(firstName) ? firstName.substring(0, 1).toUpperCase() : ""),
                react_1.default.createElement("span", { style: { color: color } }, (0, primeobjects_helper_util_1.isNonEmptyString)(lastName) ? lastName.substring(0, 1).toUpperCase() : "")))) : (react_1.default.createElement(svg_1.default, { id: "page-header-me", size: size, style: svgStyle, color: color, src: "/icons/platform/circle-user.svg" }));
    };
    var renderUser = function () {
        return menuItems && menuItems.length > 0 ? (react_1.default.createElement(react_2.Menu, { as: "div", className: "relative inline-block text-left w-full cursor-pointer ".concat(userClassName), style: userStyle },
            react_1.default.createElement(react_2.Menu.Button, { className: "flex text-sm w-full", style: { minWidth: size, minHeight: size } },
                renderAvatar(),
                renderName()),
            (0, primeobjects_helper_util_1.isNonEmptyString)(currentStatus) && (react_1.default.createElement("div", { className: "absolute right-0 top-0 rounded-full ".concat(currentStatus == "on" ? "bg-green-600" : "bg-red-600"), style: { width: 10, height: 10 } })),
            react_1.default.createElement(react_2.Transition, { as: react_1.Fragment, enter: "transition ease-out duration-100", enterFrom: "transform opacity-0 scale-95", enterTo: "transform opacity-100 scale-100", leave: "transition ease-in duration-75", leaveFrom: "transform opacity-100 scale-100", leaveTo: "transform opacity-0 scale-95" },
                react_1.default.createElement(react_2.Menu.Items, { className: "origin-top-right absolute z-50 ".concat(menuPosition == "right" ? "right-0" : "left-0", " mt-2 w-48 rounded-md shadow-lg bg-white ring-1 ring-black ring-opacity-5 focus:outline-none") },
                    react_1.default.createElement("div", { className: "py-1" }, (0, lodash_2.map)(menuItems, function (item, index) {
                        return (react_1.default.createElement(react_2.Menu.Item, { key: "".concat(item.title, "-").concat(index) }, function (_a) {
                            var active = _a.active;
                            return (react_1.default.createElement("div", { onClick: item.onClick, className: "".concat(active ? "bg-gray-100" : "", " cursor-pointer block px-4 py-1 text-base text-gray-800") }, item.title));
                        }));
                    })))))) : (react_1.default.createElement("div", { className: "relative inline-block text-left w-full ".concat(props.onClick ? "cursor-pointer" : "", " ").concat(userClassName), style: userStyle, onClick: onClick },
            react_1.default.createElement("div", { className: "flex text-sm w-full", style: { minWidth: size, minHeight: size } },
                renderAvatar(),
                renderName())));
    };
    return hide ? null : (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement("div", { className: "avatar ".concat((0, primeobjects_helper_util_1.isNonEmptyString)(wrapperClassName) ? wrapperClassName : ""), style: __assign({ height: size, position: "relative" }, wrapperStyle) },
            renderUser(),
            (0, lodash_1.isNumber)(count) && count > 0 && (react_1.default.createElement("div", { className: "flex flex-row justify-center w-full", style: __assign({ width: size / 2, height: size / 2, position: "absolute", top: -5, right: -5, borderRadius: 9, backgroundColor: primeobjects_helper_util_1.COLORS.RED["800"], justifyContent: "space-around" }, countWrapperStyle) },
                react_1.default.createElement("div", { style: __assign(__assign({}, styles.count), countStyle) }, count > 9 ? "9+" : count))))));
};
exports.Avatar = Avatar;
exports.default = exports.Avatar;
//# sourceMappingURL=avatar.js.map