//  Copyright PrimeObjects Software Inc. and other contributors <https://www.primeobjects.com/>
//
//  This source code is licensed under the MIT license.
//  The detail information can be found in the LICENSE file in the root directory of this source tree.
import React from "react";
import { COLORS, isNonEmptyString, isObject } from "primeobjects-helper-util";
import { map, without } from "lodash";
import SVG from "../svg";
import Link from "next/link";
export var HeaderMenuItems = function (props) {
    var href = isNonEmptyString(props.href) ? props.href : "#";
    var mobileView = props.mobileView == true;
    var data = props.data, title = props.title;
    return (React.createElement("div", { className: "relative grid gap-5 bg-white px-5 py-5", style: mobileView ? { paddingTop: 0 } : {} },
        isNonEmptyString(title) && (React.createElement(Link, { href: href },
            React.createElement("h3", { className: "text-sm tracking-wide border border-dashed border-t-0 border-l-0  border-r-0 font-medium text-gray-500 pb-2" }, "title"))),
        without(map(data, function (item, idx) {
            var titleColor = isNonEmptyString(item.titleColor) ? item.titleColor : COLORS.GRAY[900];
            var descColor = isNonEmptyString(item.descColor) ? item.descColor : COLORS.GRAY[500];
            var style = isObject(item.style) ? item.style : {};
            var target = isNonEmptyString(item.target) ? item.target : "_self";
            if (!isNonEmptyString(item.title) && !isNonEmptyString(item.description)) {
                item.title = "Need title or description";
            }
            return (item === null || item === void 0 ? void 0 : item.hidden) ? null : (React.createElement(Link, { key: idx, href: item.href },
                React.createElement("a", { target: target, style: style, className: "-m-3 p-3 flex items-start rounded-lg hover:bg-gray-50" },
                    React.createElement(SVG, { src: isNonEmptyString(item.icon) ? item.icon : "/icons/platform/line-arrow-right.svg", size: 16, color: titleColor, style: { minHeight: 20, marginTop: 2 }, className: "flex-shrink-0 h-6 w-6" }),
                    React.createElement("div", { className: "ml-4", style: { minHeight: 20 } },
                        isNonEmptyString(item.title) && (React.createElement("p", { className: "text-base font-medium mb-0", style: { color: titleColor } }, item.title)),
                        isNonEmptyString(item.description) && (React.createElement("p", { className: "mt-1 text-sm my-1", style: { color: descColor } }, item.description))))));
        }), null)));
};
export default HeaderMenuItems;
//# sourceMappingURL=menu-items.js.map